searchNodes=[{"doc":"A GenServer for playing a schedule of MIDI commands at predefined times.","ref":"MIDIPlayer.html","title":"MIDIPlayer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"MIDIPlayer.html#child_spec/1","title":"MIDIPlayer.child_spec/1","type":"function"},{"doc":"Generate the current schedule defined by the given events.The list of events is internally converted to MIDI commands. If multiple events are scheduled on the same time, then they are executed in the same order as in the list. The duration makes sure the player plays a (potential) pause after the last midi command.See MIDIPlayer.Event to create events.","ref":"MIDIPlayer.html#generate_schedule/2","title":"MIDIPlayer.generate_schedule/2","type":"function"},{"doc":"Get the current schedule of the player.The schedule is a list of tuples of a time in milliseconds and the corresponding bitstream of MIDI commands to be played at that time. The list is guaranteed to be ascending in time.","ref":"MIDIPlayer.html#get_schedule/0","title":"MIDIPlayer.get_schedule/0","type":"function"},{"doc":"Pause the player. See MIDIPlayer.Player.resume/0 for resuming playback.","ref":"MIDIPlayer.html#pause/0","title":"MIDIPlayer.pause/0","type":"function"},{"doc":"Play the current MIDI schedule from the start.","ref":"MIDIPlayer.html#play/0","title":"MIDIPlayer.play/0","type":"function"},{"doc":"Resume playback on the player after it has been paused.","ref":"MIDIPlayer.html#resume/0","title":"MIDIPlayer.resume/0","type":"function"},{"doc":"Set the player on repeat or not.","ref":"MIDIPlayer.html#set_repeat/1","title":"MIDIPlayer.set_repeat/1","type":"function"},{"doc":"Start the MIDI player.","ref":"MIDIPlayer.html#start_link/0","title":"MIDIPlayer.start_link/0","type":"function"},{"doc":"Stop the player and cancel the pause.","ref":"MIDIPlayer.html#stop_playing/0","title":"MIDIPlayer.stop_playing/0","type":"function"},{"doc":"","ref":"MIDIPlayer.html#t:schedule/0","title":"MIDIPlayer.schedule/0","type":"type"},{"doc":"Several musical events which can be converted to MIDI commands.All timings are in milliseconds.","ref":"MIDIPlayer.Event.html","title":"MIDIPlayer.Event","type":"module"},{"doc":"Converts the event to a list of MIDI commands.","ref":"MIDIPlayer.Event.html#convert/1","title":"MIDIPlayer.Event.convert/1","type":"function"},{"doc":"A musical event.","ref":"MIDIPlayer.Event.html#t:t/0","title":"MIDIPlayer.Event.t/0","type":"type"},{"doc":"An event which changes the current program of the given channel.","ref":"MIDIPlayer.Event.ChangeProgram.html","title":"MIDIPlayer.Event.ChangeProgram","type":"module"},{"doc":"","ref":"MIDIPlayer.Event.ChangeProgram.html#new/3","title":"MIDIPlayer.Event.ChangeProgram.new/3","type":"function"},{"doc":"An event which plays the given tone for the given timespan.","ref":"MIDIPlayer.Event.Note.html","title":"MIDIPlayer.Event.Note","type":"module"},{"doc":"","ref":"MIDIPlayer.Event.Note.html#new/5","title":"MIDIPlayer.Event.Note.new/5","type":"function"},{"doc":"MIDIPlayerA MIDI player for Elixir.","ref":"readme.html","title":"MIDIPlayer","type":"extras"},{"doc":"Install FluidSynth to play MIDI commands:On Linux:sudo apt install libfluidsynth-devOn OSX:brew install fluidsynth","ref":"readme.html#prerequisites","title":"MIDIPlayer - Prerequisites","type":"extras"},{"doc":"MIDIPlayer takes &quot;events&quot; which for example represent to play a note for a time span. It then converts these events to MIDI commands and schedules them.First, let's create some events. This plays a piano sound for the C note for 1 second:iex&gt; piano = MIDIPlayer.Event.Note.new(0, 60, 0, 1000, 127)We can change the instrument to a violin after one second like so:iex&gt; change = MIDIPlayer.Event.ChangeProgram.new(0, 1000, 41)(Note that it could be simpler to use another MIDI channel for another instrument.)Finally, play two notes on the violin at the same time:iex&gt; violin1 = MIDIPlayer.Event.Note.new(0, 67, 1000, 3000, 127) iex&gt; violin2 = MIDIPlayer.Event.Note.new(0, 64, 1000, 3000, 127)Now we are ready to play these events. First start the player like so:iex&gt; MIDIPlayer.start_link()Then load the events, and play them!iex&gt; MIDIPlayer.generate_schedule([piano, change, violin1, violin2], 3000) iex&gt; MIDIPlayer.play()","ref":"readme.html#examples","title":"MIDIPlayer - Examples","type":"extras"},{"doc":"This project uses MIDISynth for generating MIDI commands and operating the FluidSynth synthesizer. It also uses Timex for timing related functionality. Inspiration from Beats.","ref":"readme.html#thanks","title":"MIDIPlayer - Thanks","type":"extras"}]